var aktiv_UsaProx;
var scrollCheck_UsaProx;
var saveLog_UsaProxIterval;
var lastScrollPos_UsaProx;
var lastTarget;
var logVal_UsaProx;				// Initialised when page loads. Contains entire log of actions

function init_UsaProx() {
	logVal_UsaProx = "";
	window.status = "";
	aktiv_UsaProx = false;
	aktiv_schreibend = false;
	
	lastScrollPos_UsaProx = (window.Event) ? window.pageYOffset : document.body.scrollTop;
	
	processLoad_UsaProx();
	
	if(window.Event) {// if Netscape: explicit event capturing
		document.captureEvents(Event.LOAD | Event.MOUSEDOWN | Event.KEYPRESS | Event.MOUSEMOVE | Event.MOUSEOVER | Event.FOCUS | Event.BLUR | Event.UNLOAD);
		window.captureEvents(Event.RESIZE);
	}
	
	/* adding proxyScript event handlers to possible existing ones
	 * over attachEvent for IE
	 * over addEventListener for Netscape */
	if(document.attachEvent) { 
		document.attachEvent('onmousedown', processClick_UsaProx);
		document.attachEvent('onkeypress', processKeypress_UsaProx);
		document.attachEvent('onmousemove', processMousemove_UsaProx);
		document.attachEvent('onmouseover', processMouseover_UsaProx);
		document.attachEvent('onfocus', processFocus_UsaProx);
		document.attachEvent('onblur', processBlur_UsaProx);
		window.attachEvent('onresize', processResize_UsaProx);
		document.attachEvent('onunload', processUnload_UsaProx);
	}
	if(document.addEventListener) {
		document.addEventListener('mousedown', processClick_UsaProx, false);
		document.addEventListener('keypress', processKeypress_UsaProx, false);
		document.addEventListener('mousemove', processMousemove_UsaProx, false);
		document.addEventListener('mouseover', processMouseover_UsaProx, false);
		document.addEventListener('focus', processFocus_UsaProx, false);
		document.addEventListener('blur', processBlur_UsaProx, false);
		window.addEventListener('resize', processResize_UsaProx, false);
		document.addEventListener('unload', processUnload_UsaProx, false);
	}
	scrollCheck_UsaProx = window.setInterval("processScroll_UsaProx()",1000);
	saveLog_UsaProxIterval = window.setInterval("saveLog_UsaProx()",3000);
}

if(document.attachEvent) window.attachEvent('onload', init_UsaProx);
if(document.addEventListener) window.addEventListener('load', init_UsaProx, false);

// Return string of the form "2004-12-31,23:59:59"
function datestamp_UsaProx() {
	var now = new Date(); 		// "var" => is local variable
	return now.getFullYear() + "-" + (now.getMonth()+1) + "-"
	  + now.getDate() + "," + now.getHours() + ":" + now.getMinutes()
	  + ":" + now.getSeconds();
}

  
// Called from the form elements below to log things with a timestamp
// @param domObject Reference to a node in the DOM tree
// @param text String to write to log

function writeLog_UsaProx(text) {
	if(aktiv_schreibend) { window.setTimeout("writeLog_UsaProx(" + text + ")",50); return false;}
	var logline;
	var page = window.location.href;
	logLine = datestamp_UsaProx() + " " + page + " " + text;	
	//window.status = logLine; // Display logLine in status bar
	
	aktiv_schreibend = true;
	logVal_UsaProx = logVal_UsaProx + logLine + "--"; // Add logLine to interaction log
	aktiv_schreibend = false;

}

// for proxy
function saveLog_UsaProx() {
	if(logVal_UsaProx!="") {
		var loadImage = new Image(); 
		loadImage.src = "http://lo.lo/img.jpg?" + logVal_UsaProx;
		logVal_UsaProx = "";
	}
}

function processClick_UsaProx(e) {
	var ev = (window.Event) ? e : window.event;
	var target = (window.Event) ? ev.target : ev.srcElement;
	var x = (window.Event) ? ev.pageX : ev.offsetX;
	var y = (window.Event) ? ev.pageY : ev.offsetY;
	if (target.id) 	writeLog_UsaProx("click x=" + x + ";y=" + y + " target=id:" + target.id);
	else {
		if(target.name) writeLog_UsaProx("click x=" + x + ";y=" + y + " target=name:" + target.name);
		else {
			if (target.href) writeLog_UsaProx("click x=" + x + ";y=" + y + " target=link:" + target.href + "+linktext:" + target.text);
			else {
				if (target.src) {
					if (target.parentNode.href)
						writeLog_UsaProx("click x=" + x + ";y=" + y + " target=imglink:" + target.parentNode.href + "+tag:" + target.nodeName + "+src:" + target.src);
					else writeLog_UsaProx("click x=" + x + ";y=" + y + " target=element:" + target.nodeName + "+src:" + target.src);
				}
				else writeLog_UsaProx("click x=" + x + ";y=" + y + " target=unknown:" + target.nodeName);
			}
		}
	}
	saveLog_UsaProx();
}

function processKeypress_UsaProx(e) {

	var keyName = "";
	if (window.Event) {		// Netscape
		if (e.modifiers & Event.ALT_MASK)
			keyName = "Alt";
		if (e.modifiers & Event.CONTROL_MASK)
			keyName = "Ctrl";
		if (e.modifiers & Event.SHIFT_MASK)
			keyName = "Shift";
		if (e.modifiers & Event.META_MASK)
			keyName = "Meta";
		else
			keyName = String.fromCharCode(e.which);
	}
	else {  				// IE
		if (window.event.altKey)
			keyName = "Alt";
		if (window.event.ctrlKey)
			keyName = "Ctrl";
		if (window.event.shiftKey)
			keyName = "Shift";
		else
			keyName = String.fromCharCode(window.event.keyCode);
	}
	
	writeLog_UsaProx("keypress key=" + keyName);
}

function processMousemove_UsaProx(e) {

	var ev = (window.Event) ? e : window.event;
	var target = (window.Event) ? ev.target : ev.srcElement;
	var x = (window.Event) ? ev.pageX : ev.offsetX;
	var y = (window.Event) ? ev.pageY : ev.offsetY; 

	if (!aktiv_UsaProx) {
		aktiv_UsaProx = true;
		logMousemove_UsaProx(x,y);
	}
}

function processMouseover_UsaProx(e) {

	var ev = (window.Event) ? e : window.event;
	var target = (window.Event) ? ev.target : ev.srcElement;
	var x = (window.Event) ? ev.pageX : ev.offsetX;
	var y = (window.Event) ? ev.pageY : ev.offsetY; 

	if (target!=lastTarget) {
		if (target.id) 	writeLog_UsaProx("mouseover x=" + x + ";y=" + y + " target=id:" + target.id);
		else {
			if(target.name) writeLog_UsaProx("mouseover x=" + x + ";y=" + y + " target=name:" + target.name);
			else {
				if (target.href) writeLog_UsaProx("mouseover x=" + x + ";y=" + y + " target=link:" + target.href + "+linktext:" + target.text);
				else {
					if (target.src) {
						if (target.parentNode.href)
							writeLog_UsaProx("mouseover x=" + x + ";y=" + y + " target=imglink:" + target.parentNode.href + "+tag:" + target.nodeName + "+src:" + target.src);
						else writeLog_UsaProx("mouseover x=" + x + ";y=" + y + " target=element:" + target.nodeName + "+src:" + target.src);
					}
				}
			}
		}
	}
	lastTarget = target;
}

function logMousemove_UsaProx(x,y) {
	writeLog_UsaProx("mousemove x=" + x + ";y=" + y);
	window.setTimeout('setInaktiv_UsaProx()',300);
}

function setInaktiv_UsaProx() {
	aktiv_UsaProx = false;
}

function processBlur_UsaProx() {
	writeLog_UsaProx("blur");
	saveLog_UsaProx();
}

function processFocus_UsaProx() {
	writeLog_UsaProx("focus");
	saveLog_UsaProx();
}

function processResize_UsaProx() {
	var newWidth, newHeight;
	if (window.innerWidth) newWidth = window.innerWidth;	// Netscape
	else newWidth = document.body.offsetWidth;
	if (window.innerHeight) newHeight = window.innerHeight;	// Netscape
	else newHeight = document.body.offsetHeight;
	writeLog_UsaProx("resize width=" + newWidth + ";height=" + newHeight);
	saveLog_UsaProx();
}

function processLoad_UsaProx() {
	var loadWidth, loadHeight;
	if (window.innerWidth) loadWidth = window.innerWidth;	// Netscape
	else loadWidth = document.body.offsetWidth;
	if (window.innerHeight) loadHeight = window.innerHeight;	// Netscape
	else loadHeight = document.body.offsetHeight;
	writeLog_UsaProx("load width=" + loadWidth + ";height=" + loadHeight);
	saveLog_UsaProx();
}

function processUnload_UsaProx() {
	writeLog_UsaProx("unload");
	saveLog_UsaProx();
}

function processScroll_UsaProx() {
    var currentScrollPos = (window.Event) ? window.pageYOffset : document.body.scrollTop;
	if(lastScrollPos_UsaProx != currentScrollPos) {
		writeLog_UsaProx("scrolledTo y=" + currentScrollPos);
		lastScrollPos_UsaProx = currentScrollPos;
		saveLog_UsaProx();
	}
}
